## curlpp 0.8.1

=== CMakeLists.txt ===
project(curlpp) 


# In response to CMake 3.0 generating warnings regarding policy CMP0042,
# the OSX RPATH settings have been updated per recommendations found
# in the CMake Wiki:
#  http://www.cmake.org/Wiki/CMake_RPATH_handling#Mac_OS_X_and_the_RPATH
if(POLICY CMP0042)
    cmake_policy(SET CMP0042 NEW) # MACOSX_RPATH
    set(CMAKE_MACOSX_RPATH TRUE)
endif()

# for unix platform, define install directories.
include(GNUInstallDirs)

if(WIN32)
    # cmake 3.4 is required for CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS
    cmake_minimum_required(VERSION 3.4)

    # c++ 11 support from cmake 3.4 or newer
    set(CMAKE_CXX_STANDARD 11) # C++11...
    set(CMAKE_CXX_STANDARD_REQUIRED ON) #...is required...
    set(CMAKE_CXX_EXTENSIONS OFF) #...without compiler extensions like gnu++11

    set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)
  else()
    if (${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION} VERSION_LESS 3.1)
        cmake_minimum_required(VERSION 2.8)
        # c++11 support for cmake 2.8.12 - 3.0.x
        #
        # for non-windows platform we try to keep cmake 2.8 support
        # since entreprise distribution tends to have 2.8 version.
        add_compile_options(-std=c++11)
    else()
        # c++ 11 support from cmake 3.1 or newer
        set(CMAKE_CXX_STANDARD 11) # C++11...
        set(CMAKE_CXX_STANDARD_REQUIRED ON) #...is required...
        set(CMAKE_CXX_EXTENSIONS OFF) #...without compiler extensions like gnu++11
    endif()
endif()


# Conan.io integration
if(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/conanbuildinfo.cmake)
    include(${CMAKE_CURRENT_SOURCE_DIR}/conanbuildinfo.cmake)
    conan_basic_setup()
endif()

# extra (pkg-config-related files)
add_subdirectory(extras)

#########################################################################################
# Look for dependencies

# Documented at https://cmake.org/cmake/help/v3.0/module/FindCURL.html?highlight=curlpp
# Seems simple.

message(STATUS "Looking for CURL")
include(FindCURL)
find_package(CURL REQUIRED)

if(CURL_FOUND)
  message(STATUS "Found CURL version: ${CURL_VERSION_STRING}")
  message(STATUS "Using CURL include dir(s): ${CURL_INCLUDE_DIRS}")
  message(STATUS "Using CURL lib(s): ${CURL_LIBRARIES}")
else()
  message(FATAL_ERROR "Could not find CURL")
endif()

# All following targets should search these directories for headers
include_directories( 
  ${CMAKE_CURRENT_SOURCE_DIR}/include
  ${CURL_INCLUDE_DIRS}
)

#########################################################################################
# Define Targets

# If building on windows, install path will be in build/winbuild
if(CMAKE_SYSTEM MATCHES "Windows")
   set(CMAKE_INSTALL_PREFIX "winbuild")
endif()

file(GLOB_RECURSE HeaderFileList "${CMAKE_CURRENT_SOURCE_DIR}/include/*")
file(GLOB_RECURSE SourceFileList "${CMAKE_CURRENT_SOURCE_DIR}/src/*")
add_library(${PROJECT_NAME} SHARED ${HeaderFileList} ${SourceFileList})
target_link_libraries(${PROJECT_NAME} ${CURL_LIBRARIES} ${CONAN_LIBS})
set_target_properties(${PROJECT_NAME} PROPERTIES SOVERSION 1 VERSION 1.0.0)

add_library(${PROJECT_NAME}_static STATIC ${HeaderFileList} ${SourceFileList})

# Make sure that on unix-platforms shared and static libraries have
# the same root name, but different suffixes.
#
#  (solution taken from https://cmake.org/Wiki/CMake_FAQ#How_do_I_make_my_shared_and_static_libraries_have_the_same_root_name.2C_but_different_suffixes.3F)
# 
# Making shared and static libraries have the same root name, but different suffixes
SET_TARGET_PROPERTIES(${PROJECT_NAME}_static PROPERTIES OUTPUT_NAME ${PROJECT_NAME})
# Now the library target "curlpp_static" will be named "curlpp.lib" with MS tools.
# This conflicts with the "curlpp.lib" import library corresponding to "curlpp.dll",
# so we add a "lib" prefix (which is default on other platforms anyway):
SET_TARGET_PROPERTIES(${PROJECT_NAME}_static PROPERTIES PREFIX "lib")
target_link_libraries(${PROJECT_NAME}_static ${CURL_LIBRARIES} ${CONAN_LIBS})

# install headers
install(DIRECTORY include/utilspp/ DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/utilspp")
install(DIRECTORY include/curlpp/ DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/curlpp")

install(TARGETS ${PROJECT_NAME} ${PROJECT_NAME}_static
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})

=== examples/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
include(FindPkgConfig)
pkg_check_modules(CURLPP REQUIRED curlpp)

set(CMAKE_CXX_STANDARD 11) # C++11...
set(CMAKE_CXX_STANDARD_REQUIRED ON) #...is required...
set(CMAKE_CXX_EXTENSIONS OFF) #...without compiler extensions like gnu++11


file(GLOB ExamplesFileList "*.cpp")

# Create a meta target to create examples
add_custom_target(build_all_examples COMMENT A target that requires all the examples.)

message(STATUS "Creating build rules for Examples:")
foreach(Example ${ExamplesFileList})
  message(STATUS "\tCreating build rule for ${Example}")
  # Get the name without extension or directory
  get_filename_component(ExampleName ${Example} NAME_WE)
  # Define example executable
  add_executable(${ExampleName} ${Example})
  # Link example against curlpp
  target_link_libraries(${ExampleName} ${CURLPP_LDFLAGS})
  # make the meta target depend on this example.
  add_dependencies(build_all_examples ${ExampleName})
endforeach(Example ${ExamplesFileList})

=== extras/CMakeLists.txt ===
# extracting curlpp version text + version num
file (READ ${CMAKE_CURRENT_SOURCE_DIR}/../include/curlpp/cURLpp.hpp CURLPP_VERSION_H_CONTENTS)

string (REGEX MATCH "#define LIBCURLPP_VERSION \"[^\"]*"
  CURLPP_VERSION ${CURLPP_VERSION_H_CONTENTS})
string (REGEX REPLACE "[^\"]+\"" "" CURLPP_VERSION ${CURLPP_VERSION})
string (REGEX MATCH "#define LIBCURLPP_VERSION_NUM 0x[0-9a-fA-F]+"
  CURLPP_VERSION_NUM ${CURLPP_VERSION_H_CONTENTS})
string (REGEX REPLACE "[^0]+0x" "" CURLPP_VERSION_NUM ${CURLPP_VERSION_NUM})

message(STATUS "curlpp version=[${CURLPP_VERSION}]")
message(STATUS "curlpp version num=[${CURLPP_VERSION_NUM}]")


# curlpp-config needs the following options to be set.
string(REPLACE "." "" libext "${CMAKE_STATIC_LIBRARY_SUFFIX}")
set(CC "${CMAKE_C_COMPILER}")
set(libdir "${CMAKE_INSTALL_LIBDIR}")
set(libdir_static "${CMAKE_INSTALL_LIBDIR}")
set(includedir "${CMAKE_INSTALL_INCLUDEDIR}")
set(prefix "${CMAKE_INSTALL_PREFIX}")

set(LDFLAGS "${CMAKE_SHARED_LINKER_FLAGS}")

# Finally generate a "curl-config" matching this config
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/curlpp-config.in"
               "${CMAKE_CURRENT_BINARY_DIR}/curlpp-config" @ONLY)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/curlpp-config"
        DESTINATION ${CMAKE_INSTALL_BINDIR}
        PERMISSIONS
          OWNER_READ OWNER_WRITE OWNER_EXECUTE
          GROUP_READ GROUP_EXECUTE
          WORLD_READ WORLD_EXECUTE)


# Finally generate a pkg-config file matching this config
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/curlpp.pc.in"
               "${CMAKE_CURRENT_BINARY_DIR}/curlpp.pc" @ONLY)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/curlpp.pc"
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

## curlpp 0.6.0-1

=== debian/changelog ===
curlpp (0.6.0-1) unstable; urgency=low

  * Initial debianization

 -- Dmitry Rozhkov <dmitry.1.rozhkov@nokia.com>  Wed, 23 May 2007 15:49:23 +0300

=== debian/control ===
Source: curlpp
Section: libs
Priority: optional
Maintainer: Dmitry Rozhkov <dmitry.1.rozhkov@nokia.com>
Build-Depends: debhelper (>= 4.1.0), cdbs, libcurl3-dev
Standards-Version: 3.6.1.0

Package: libcurlpp0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: CURL bindings for C++
 CURL bindings for C++

Package: libcurlpp-dev
Section: libs
Architecture: any
Depends: libcurlpp0 (= ${Source-Version}), libcurl3-dev
Description: CURL bindings for C++. Developement package.
 CURL bindings for C++

Package: libcurlpp-utils
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: CURL bindings for C++. Utils
 CURL bindings for C++. Utils

## curlpp 0.6.0-2

=== debian/changelog ===
curlpp (0.6.0-2) unstable; urgency=low

  * namespace added to Info.cpp. Fixes: NB#78154

 -- Dmitry Rozhkov <dmitry.1.rozhkov@nokia.com>  Fri,  7 Dec 2007 11:29:03 +0200

=== debian/control ===
--- 
+++ 
@@ -16,13 +16,13 @@
 Section: libs
 Architecture: any
 Depends: libcurlpp0 (= ${Source-Version}), libcurl3-dev
-Description: CURL bindings for C++. Developement package.
+Description: CURL bindings for C++. Development package.
  CURL bindings for C++
 
 Package: libcurlpp-utils
 Section: libs
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
-Description: CURL bindings for C++. Utils
- CURL bindings for C++. Utils
+Description: CURL bindings for C++. Utilities 
+ CURL bindings for C++. Utilities

=== debian/rules ===
#! /usr/bin/make -f

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/autotools.mk

DEB_DH_INSTALL_SOURCEDIR=debian/tmp
DEB_DESTDIR=$(CURDIR)/debian/tmp


ifneq (,$(findstring parallel,$(DEB_BUILD_OPTIONS)))
        PARALLEL_JOBS := $(shell echo $(DEB_BUILD_OPTIONS) | \
                sed -e 's/.*parallel=\([0-9]\+\).*/\1/')
        ifeq ($(DEB_BUILD_OPTIONS),$(PARALLEL_JOBS))
                PARALLEL_JOBS := $(shell if [ -f /proc/cpuinfo ]; \
                        then echo `cat /proc/cpuinfo | grep 'processor' | wc -l`; \
                        else echo 1; fi)
        endif
        NJOBS := -j$(PARALLEL_JOBS)
endif
DEB_MAKE_ENVVARS := MAKEFLAGS=$(NJOBS)

## curlpp 0.7.3

=== debian/changelog ===
curlpp (0.7.3-2) unstable; urgency=low

  * Don't install config.h nor include it in headers.

 -- Ximin Luo <infinity0@gmx.com>  Sat, 21 Sep 2013 12:10:31 +0100

curlpp (0.7.3-1) unstable; urgency=low

  [ Goedson Teixeira Paixao ]
  * Fix Makefile.in to include config.h

  [ Ximin Luo ]
  * Patch global.h so users don't need to define HAVE_CONFIG_H
  * Initial release (Closes: #592133)

 -- Ximin Luo <infinity0@gmx.com>  Wed, 18 Sep 2013 19:03:56 +0100

=== debian/control ===
Source: curlpp
Priority: extra
Maintainer: Ximin Luo <infinity0@gmx.com>
Build-Depends: debhelper (>= 9), autotools-dev, libboost-dev (>= 1.33), libcurl4-openssl-dev | libcurl4-dev
Standards-Version: 3.9.4
Section: libs
Homepage: http://www.curlpp.org/
Vcs-Git: git://anonscm.debian.org/users/infinity0-guest/curlpp.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=users/infinity0-guest/curlpp.git

Package: libcurlpp0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: c++ wrapper for libcurl
 curlpp provides a C++ wrapper for the libcurl library
 .
 This package provides the shared libraries needed to run
 programs using curlpp.

Package: libcurlpp-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, libcurlpp0 (= ${binary:Version})
Description: c++ wrapper for libcurl (development files)
 curlpp provides a C++ wrapper for the libcurl library
 .
 This package provides the include files and static libraries
 needed to build programs using curlpp.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@ 

override_dh_installdocs:
	dh_installdocs --link-doc=libcurlpp0

override_dh_installchangelogs:
	dh_installchangelogs CHANGES

=== debian/watch ===
version=3
http://code.google.com/p/curlpp/downloads/list .*/curlpp-(\d\S*)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## curlpp 0.8.1

=== debian/changelog ===
curlpp (0.8.1-6) unstable; urgency=medium

  [ Debian Janitor ]
  * Use secure URI in Homepage field.
  * Drop unnecessary dependency on dh-autoreconf.
  * Remove constraints unnecessary since buster (oldstable):
    + Build-Depends: Drop versioned constraint on g++ and libboost-dev.

  [ Aloïs Micard ]
  * d/source/lintian-overrides:
    - Silence OpenPGP signature check.
  * d/copyright:
    - Update copyright years.
  * d/control:
    - Bump Standards-Version.
  * d/patches:
    - Write patch to build with new libcurl version. (Closes: #1082972)
  * d/libcurlpp0t64.lintian-overrides:
    - Fix lintian overrides.

 -- Aloïs Micard <creekorful@debian.org>  Fri, 01 Nov 2024 10:55:52 +0100

curlpp (0.8.1-5.3) unstable; urgency=medium

  * Non-maintainer upload.
  * Drop libcurlpp0 shlibs override in rules file, soname bump
    has happened. (Closes: #1067731)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 26 Mar 2024 07:45:08 +0100

curlpp (0.8.1-5.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1061993

 -- Michael Hudson-Doyle <mwhudson@debian.org>  Tue, 27 Feb 2024 23:23:36 +0000

curlpp (0.8.1-5.1) unstable; urgency=medium

  * Non-maintainer upload.
  * libcurlpp-dev: Perform symlink to directory conversion of
    /usr/share/doc/libcurlpp-dev.  (Closes: #1035631)

 -- Andreas Beckmann <anbe@debian.org>  Thu, 25 May 2023 15:39:56 +0200

curlpp (0.8.1-5) unstable; urgency=medium

  * Do not ship symbols at the moment.

 -- Aloïs Micard <creekorful@debian.org>  Fri, 03 Sep 2021 09:36:39 +0200

curlpp (0.8.1-4) unstable; urgency=medium

  * d/control:
    - Bump Standards-Version.
    - Update my uploader email.
  * Now install examples.
  * d/upstream/metadata: Remove Homepage field.
  * Enabled hardening=+bindnow.
  * Export library symbols.

 -- Aloïs Micard <creekorful@debian.org>  Thu, 02 Sep 2021 10:11:04 +0200

curlpp (0.8.1-3) unstable; urgency=medium

  * Make myself maintainer. (Closes: #907733)
  * Bump debhelper compat.
  * Mark libcurl4-nss-dev as conflict. (Closes: #907496)

 -- Aloïs Micard <alois@micard.lu>  Mon, 19 Oct 2020 22:37:23 +0200

curlpp (0.8.1-2.1) unstable; urgency=medium

  * Non-maintainer upload
  * Fix version field export. (Closes: #868108)
  * Fix misssing depends on libcurl-dev. (Closes: #867666)
  * d/upstream/metadata: add upstream metadata.

 -- Aloïs Micard <alois@micard.lu>  Mon, 10 Aug 2020 06:37:47 +0200

curlpp (0.8.1-2) unstable; urgency=medium

  * Deal with GCC-7 op mangling. (Closes: #871281)
  * Update to latest Standards-Version. Changes:
    - Change Priority from extra to optional.

 -- Ximin Luo <infinity0@debian.org>  Thu, 24 Aug 2017 16:15:34 +0200

curlpp (0.8.1-1) unstable; urgency=medium

  * New upstream release. (Closes: #811959)
  * Update to latest Standards-Version.

 -- Ximin Luo <infinity0@debian.org>  Mon, 20 Mar 2017 19:19:37 +0100

curlpp (0.7.3-6) unstable; urgency=medium

  [ Dimitri John Ledkov ]
  * Fix ftbfs with gcc-4.9. (Closes: #746841)

 -- Ximin Luo <infinity0@pwned.gg>  Sat, 17 May 2014 17:23:16 +0100

curlpp (0.7.3-5) unstable; urgency=low

  [ Logan Rosen ]
  * Use dh-autoreconf instead of autotools-dev to also fix FTBFS on ppc64el by
    getting new libtool macros. (Closes: #733081)

  [ Ximin Luo ]
  * Update to latest Standards-Version.

 -- Ximin Luo <infinity0@pwned.gg>  Fri, 07 Feb 2014 15:59:50 +0000

curlpp (0.7.3-4) unstable; urgency=low

  * Don't mess with quilt patches during clean; it's more properly taken care
    of by dpkg-source instead. (Closes: #728097)

 -- Ximin Luo <infinity0@gmx.com>  Tue, 29 Oct 2013 13:40:09 +0000

curlpp (0.7.3-3) unstable; urgency=low

  * Update autotools config to take into account newer architectures
    (Closes: #727350)
  * Pre-emptively remove curlpp.spec via quilt so it can be restored later when
    `dh clean` gets rid of it

 -- Ximin Luo <infinity0@gmx.com>  Thu, 24 Oct 2013 14:20:44 +0100

=== debian/control ===
Source: curlpp
Priority: optional
Maintainer: Aloïs Micard <creekorful@debian.org>
Uploaders: Ximin Luo <infinity0@debian.org>
Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13),
 cmake,
 libboost-dev,
 libcurl4-openssl-dev | libcurl4-dev
Build-Conflicts: libcurl4-nss-dev
Standards-Version: 4.7.0
Rules-Requires-Root: no
Section: libs
Homepage: https://www.curlpp.org/
Vcs-Git: https://salsa.debian.org/creekorful/curlpp.git
Vcs-Browser: https://salsa.debian.org/creekorful/curlpp

Package: libcurlpp0t64
Provides: ${t64:Provides}
Replaces: libcurlpp0
Breaks: libcurlpp0 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: c++ wrapper for libcurl
 curlpp provides a C++ wrapper for the libcurl library
 .
 This package provides the shared libraries needed to run
 programs using curlpp.

Package: libcurlpp-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, libcurlpp0t64 (= ${binary:Version}),
 libcurl4-openssl-dev | libcurl4-dev
Conflicts: libcurl4-nss-dev
Description: c++ wrapper for libcurl (development files)
 curlpp provides a C++ wrapper for the libcurl library
 .
 This package provides the include files and static libraries
 needed to build programs using curlpp.

=== debian/rules ===
--- 
+++ 
@@ -9,11 +9,8 @@
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
 
+# hardening
+export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow
+
 %:
-	dh $@ 
-
-override_dh_installdocs:
-	dh_installdocs --link-doc=libcurlpp0
-
-override_dh_installchangelogs:
-	dh_installchangelogs CHANGES
+	dh $@
